"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var context_1 = require("../context");
var Connection = /** @class */ (function (_super) {
    __extends(Connection, _super);
    function Connection() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            connections: [],
        };
        _this.componentDidMount = function () {
            var server = _this.context;
            server.on("connection", function (socket) {
                if (_this.props.onConnection)
                    _this.props.onConnection(socket);
                if (_this.props.children) {
                    _this.setState(function (state) {
                        if (_this.props.children) {
                            state.connections.push({
                                socket: socket,
                                id: socket.id,
                                children: _this.props.children(socket),
                            });
                            return {
                                connections: state.connections.filter(function (connection) { return !connection.socket.disconnected; }),
                            };
                        }
                    });
                }
            });
        };
        return _this;
    }
    Connection.prototype.render = function () {
        return (react_1.default.createElement(react_1.default.Fragment, null, this.state.connections.map(function (connection) { return (react_1.default.createElement(react_1.default.Fragment, { key: connection.id },
            react_1.default.createElement(context_1.SocketConnectionContext.Provider, { value: connection.socket },
                react_1.default.createElement(context_1.NamespaceContext.Provider, { value: connection.socket }, connection.children)))); })));
    };
    Connection.contextType = context_1.NamespaceContext;
    return Connection;
}(react_1.default.Component));
exports.default = Connection;
